diff --git a/Source/Base/Spring.HazardEra.pas b/Source/Base/Spring.HazardEra.pas
index 2c6134f6b3a112ab9389da15a4091432360b602c..9e0a30a7eac438e19569fbf87404616cad5fa275 100644
--- a/Source/Base/Spring.HazardEra.pas
+++ b/Source/Base/Spring.HazardEra.pas
@@ -314,25 +314,33 @@ var
 begin
   currEra := AtomicLoad(eraClock);
 
-  lock.Acquire;
-  try
-    if Assigned(p) then
-    begin
-      p.delEra := currEra;
-      retiredList.Add(p);
-    end;
-
-    if AtomicLoad(eraClock) = currEra then
-      AtomicIncrement(eraClock);
+  if Assigned(lock) then
+  begin
+    lock.Acquire;
+    try
+      if Assigned(p) then
+      begin
+        p.delEra := currEra;
+        retiredList.Add(p);
+      end;
 
-    i := 0;
-    while i < retiredList.Count do
-      if Delete_Ptr(retiredList[i]) then
-        retiredList.Delete(i)
-      else
-        Inc(i);
-  finally
-    lock.Release;
+      if AtomicLoad(eraClock) = currEra then
+        AtomicIncrement(eraClock);
+
+      i := 0;
+      while i < retiredList.Count do
+        if Delete_Ptr(retiredList[i]) then
+          retiredList.Delete(i)
+        else
+          Inc(i);
+    finally
+      lock.Release;
+    end;
+  end
+  else
+  begin
+    p.delEra := currEra;
+    Delete_ptr(p);
   end;
 end;
 
@@ -433,5 +441,6 @@ finalization
   Retire(nil);
   retiredList.Free;
   lock.Free;
+  lock := nil;
 
 end.
